' Quick Starter v1.1
' :
' http://script-coding.info/
'   :
' http://forum.script-coding.info/

Public Class WinForm
Inherits System.Windows.Forms.Form
Private TreeView As New System.Windows.Forms.TreeView
'==================================================================================================
' Main
'==================================================================================================
Public Shared Sub Main()
    System.Windows.Forms.Application.Run(New WinForm())
End Sub
'==================================================================================================
'  
'==================================================================================================
Public Sub New()
    MyBase.New()
    
    Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\QuickStarter\Settings")
    Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\QuickStarter\Tree")
    
    Dim Key As Microsoft.Win32.RegistryKey
    Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Settings")
    
    ' 
    MyBase.Icon = System.Drawing.SystemIcons.Application
    
    '   
    MyBase.Text = CType(Key.GetValue("Title"), String)
    '   
    MyBase.Topmost = CType(Key.GetValue("Topmost"), Boolean)
    
    '  
    Dim Height As Long = CType(Key.GetValue("Height"), Long)
    If Height > 0 Then
        MyBase.Height = Height
    Else
        MyBase.Height = 350
    End If
    Dim _Width As Long = CType(Key.GetValue("Width"), Long)
    If _Width > 0 Then
        MyBase.Width = _Width
    Else
        MyBase.Width = 450
    End If
    
    ' 
    AddHandler TreeView.KeyPress, AddressOf TreeView_KeyPress
    AddHandler TreeView.DoubleClick, AddressOf TreeView_DoubleClick
    TreeView.Dock = System.Windows.Forms.DockStyle.Fill
    Dim FontSize As Long = CType(Key.GetValue("FontSize"), Long)
    If 7 <= FontSize And FontSize <= 20 Then
        TreeView.Font = New System.Drawing.Font(TreeView.Font.Name, FontSize, TreeView.Font.Style)
    End If
    Dim Bold As Long = CType(Key.GetValue("Bold"), Boolean)
    If Bold Then
        TreeView.Font = New System.Drawing.Font(TreeView.Font, TreeView.Font.Style Or System.Drawing.FontStyle.Bold)
    End If
    MyBase.Controls.Add(TreeView)
    
    '  
    Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Tree")
    EnumKeys(Key, TreeView.Nodes)
    Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Settings")
    Dim SaveTreeState As Long = CType(Key.GetValue("SaveTreeState"), Boolean)
    If SaveTreeState Then
        SetNodesState(TreeView.Nodes)
    End If
    
    MyBase.Show()
End Sub
'==================================================================================================
'    ( )
'==================================================================================================
Private Sub EnumKeys(Key As Microsoft.Win32.RegistryKey, Nodes As System.Windows.Forms.TreeNodeCollection)
    If Key.SubKeyCount <= 0 Then Exit Sub
    Dim SubKey As Microsoft.Win32.RegistryKey
    Dim SubKeyName As String
    For Each SubKeyName In Key.GetSubKeyNames()
        Dim newNode As New System.Windows.Forms.TreeNode(SubKeyName)
        Nodes.Add(newNode)
        SubKey = Key.OpenSubKey(SubKeyName)
        If SubKey.SubKeyCount <= 0 Then
            newNode.Tag = SubKey.GetValue("") '    
        End If
        EnumKeys(SubKey, Nodes(Nodes.Count - 1).Nodes)
    Next
End Sub
'==================================================================================================
'   (   )
'==================================================================================================
Private Sub EnumNodes(Nodes As System.Windows.Forms.TreeNodeCollection)
    Dim Node As System.Windows.Forms.TreeNode
    Dim Key As Microsoft.Win32.RegistryKey
    For Each Node In Nodes
        Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Tree\" & Node.FullPath, True)
        If Node.IsExpanded Then
            Key.SetValue("IsExpanded", 1)
        Else
            Key.SetValue("IsExpanded", 0)
        End If
        If Node.IsSelected Then
            Key.SetValue("IsSelected", 1)
        Else
            Key.SetValue("IsSelected", 0)
        End If
        EnumNodes(Node.Nodes)
    Next
End Sub
'==================================================================================================
'   (   )
'==================================================================================================
Private Sub SetNodesState(Nodes As System.Windows.Forms.TreeNodeCollection)
    Dim Node As System.Windows.Forms.TreeNode
    Dim Key As Microsoft.Win32.RegistryKey
    For Each Node In Nodes
        Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Tree\" & Node.FullPath)
        Dim IsExpanded As Long = CType(Key.GetValue("IsExpanded"), Boolean)
        If IsExpanded Then
            Node.Expand
        End If
        Dim IsSelected As Long = CType(Key.GetValue("IsSelected"), Boolean)
        If IsSelected Then
            TreeView.SelectedNode = Node
        End If
        SetNodesState(Node.Nodes)
    Next
End Sub
'==================================================================================================
'  
'==================================================================================================
Private Sub Run
    On Error Resume Next
    If TreeView.SelectedNode.Tag Is Nothing Then Exit Sub
    'Dim Proc As New System.Diagnostics.Process
    'Proc.Start(TreeView.SelectedNode.Tag)
    Dim WshShell As Object
    WshShell = CreateObject("WScript.Shell")
    If Err.Number <> 0 Then
        MsgBox(Err.Description)
        MyClass.Close()
    End If
    WshShell.Run(TreeView.SelectedNode.Tag, 1)
    If Err.Number <> 0 Then
        MsgBox(Err.Description)
    End If
    '   Shift,   
    If System.Windows.Forms.Control.ModifierKeys And System.Windows.Forms.Keys.Shift Then
    Else
        MyClass.Close()
    End If
End Sub
'==================================================================================================
'  KeyPress  (  Escape)
'==================================================================================================
Private Sub WinForm_KeyPress (ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) _
    Handles MyBase.KeyPress
    If e.KeyChar = Microsoft.VisualBasic.ChrW(27) Then ' Escape
        MyClass.Close()
    End If
End Sub
'==================================================================================================
'  KeyPress  TreeView
'==================================================================================================
Public Sub TreeView_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
    If e.KeyChar = Microsoft.VisualBasic.ChrW(27) Then ' Escape
        MyClass.Close()
    ElseIf e.KeyChar = Microsoft.VisualBasic.ChrW(32) Then ' Space
        Run()
    ElseIf e.KeyChar = Microsoft.VisualBasic.ChrW(13) Then ' Enter
        Run()
    End If
End Sub
'==================================================================================================
'  DoubleClick  TreeView
'==================================================================================================
Public Sub TreeView_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs)
    Run()
End Sub
'==================================================================================================
'  Load 
'==================================================================================================
Private Sub WinForm_Load (ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
    Dim Key As Microsoft.Win32.RegistryKey
    Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Settings")
    
    '  
    Dim _Left As Long = CType(Key.GetValue("Left"), Long)
    If _Left >= 0 Then
        MyBase.Left = _Left
    End If
    Dim Top As Long = CType(Key.GetValue("Top"), Long)
    If Top >= 0 Then
        MyBase.Top = Top
    End If
    If _Left < 0 Or Top < 0 Then
        '      
	    Dim w As Integer = MyBase.Width : Dim h As Integer = MyBase.Height '    
	    Dim wD As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width '   
	    Dim hD As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height '   
	    Dim T As Integer = (hD - h) / 2
	    Dim L As Integer = (wD - w) / 2
	    MyBase.SetDesktopLocation(L, T)
    End If
    '  
    Dim Maximized As Long = CType(Key.GetValue("Maximized"), Long)
    If Maximized = 1 Then
        MyBase.WindowState = System.Windows.Forms.FormWindowState.Maximized
    End If
End Sub
'==================================================================================================
'  OnClosing 
'==================================================================================================
Protected Overrides Sub OnClosing (ByVal e As System.ComponentModel.CancelEventArgs)
    Dim Key As Microsoft.Win32.RegistryKey
    Key = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\QuickStarter\Settings", True)
    
    '   
    Dim SaveSize As Long = CType(Key.GetValue("SaveSize"), Boolean)
    If SaveSize Then
        If MyBase.WindowState = System.Windows.Forms.FormWindowState.Maximized Then
            Key.SetValue("Maximized", 1)
        Else
            Key.SetValue("Maximized", 0)
            Key.SetValue("Height", MyBase.Height)
            Key.SetValue("Width", MyBase.Width)
        End If
    End If
    
    '   
    Dim SaveLocation As Long = CType(Key.GetValue("SaveLocation"), Boolean)
    If SaveLocation Then
        Key.SetValue("Left", MyBase.Left)
        Key.SetValue("Top", MyBase.Top)
    End If
    
    '    
    Dim SaveTreeState As Long = CType(Key.GetValue("SaveTreeState"), Boolean)
    If SaveTreeState Then
        EnumNodes(TreeView.Nodes)
    End If
End Sub
End Class